#!/usr/bin/perl

#---------------------------------------------------------------------------------------------------#
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) 
 {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
 }
$temp = $ENV{'QUERY_STRING'};
@pairs = split(/&/,$temp);
foreach $item(@pairs) 
 {
  ($key, $content) = split (/=/, $item, 2);
  $content =~ tr/+/ /;
  $content =~ s/%(..)/pack("c",hex($1))/ge;
  $FORM{$key} = $content;
 }
#---------------------------------------------------------------------------------------------------#
sub get_WORD
 { return unpack "v", (substr $_[0],$_[1],4); }

sub get_DWORD
 { return unpack "V", (substr $_[0],$_[1],4); }

sub get_WORD_symbols
 { return pack "v", $_[0]; }

sub get_DWORD_symbols
 { return pack "V", $_[0]; }

sub read_block
 {
  open FILE,$_[0];
  $stat_info .= ($_[2]."    ".$_[1]."<br>");
  binmode FILE;
  seek FILE,$_[1],0; read FILE,$_[3],$_[2];
  close FILE;
 }

sub get_time
 {
  ($sec, $min, $hour) = (localtime)[0..2];
  if($sec < 10){ $sec = "0$sec"; };
  if($min < 10){ $min = "0$min"; };
  if($hour < 10){ $hour = "0$hour"; };
  return "$hour:$min:$sec";
 }

sub reset_document
 {
  $stat_info =~ s/\x5c/\\x5c/g;
  my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";
  print <<HTML;
  <script type='text/javascript'><!--
  parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == "yes") ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
  parent.document.save_tlk_form.reset();
  parent.FLAG_no_action = 0;
  parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
  // --></script>
HTML

  exit;
 }

sub flag_correction_v1
 {
  if(ord $current_sound_link && length $current_string_content == 0){ $new_string_flag = get_WORD_symbols(2); }
  elsif($current_string_content =~ /<[a-zA-Z]{1}[^>]*>/){ $new_string_flag = get_WORD_symbols(7); }
  elsif(ord $current_string_content){ $new_string_flag = get_WORD_symbols(3); }
  else{ $new_string_flag = get_WORD_symbols(0); }
 }

sub flag_correction_v3
 {
  if(ord $current_sound_link){ $new_string_flag = get_WORD_symbols(7); }
  elsif(ord $current_string_content){ $new_string_flag = get_WORD_symbols(1); }
  else{ $new_string_flag = get_WORD_symbols(0); }
 }

#---------------------------------------------------------------------------------------------------#
#  
#---------------------------------------------------------------------------------------------------#

my $main_file = $FORM{'main_file'};
my $add_file = $FORM{'add_file'};
my $ERROR_file_read = ":         !<br>";
my $ERROR_file_type = ":     TLK !<br>";
my $ERROR_file_version = ":     !<br>";

#---------------------------------------------------------------------------------------------------#
print "content-type: text/html; charset=Windows-1251\n\n";
#---------------------------------------------------------------------------------------------------#

$stat_info .= "<b>  tlk-</b> ...<br> tlk-:<br><nobr>".$main_file."</nobr><br>";
if(!-r $main_file){ $stat_info .= $ERROR_file_read; reset_document(); };

#---------------------------------------------------------------------------------------------------#
#  
#---------------------------------------------------------------------------------------------------#
open FILE,$main_file;
#     ( )
(undef, undef, undef, undef, undef, undef, undef, $file_size) = stat FILE;
#  
close FILE;
$stat_info .= "->    ... ";
read_block($main_file,0,20,$header);
#   
$file_type = substr $header,0,4;
if($file_type ne "TLK "){ $stat_info .= $ERROR_file_type; reset_document(); };

#  
$file_version = substr $header,4,4;
if($file_version eq "V3.0")
 { $header_length = 20; $string_data_length = 40; $stat_info .= "->    ... V3.0<br>"; }
elsif($file_version eq "V1  ")
 { $header_length = 18; $string_data_length = 26; $stat_info .= "->    ... V1<br>"; }
else{ $stat_info .= $ERROR_file_version; reset_document(); }

#  
%language_list = ('0','', '1','', '2','', '3','', '4','', '5','', '6','', '128','', '129',' ', '130',' ', '131','');
#   (    )
$languageID = ($file_version eq "V3.0") ? get_DWORD($header,8) : get_WORD($header,8);
$file_language = $language_list{$languageID};

#     
$file_strings = ($file_version eq "V3.0") ? get_DWORD($header,12) - 1 : get_DWORD($header,10) - 1;
#        
$strings_offset = ($file_version eq "V3.0") ? get_DWORD($header,16) : get_DWORD($header,14);


$stat_info .= "->       ... ";
read_block($main_file,$header_length,$strings_offset-$header_length,$strings_data_table);
$stat_info .= "->     ... ";
read_block($main_file,$strings_offset,$file_size-$strings_offset,$strings_content);

#   
$strings_added = 0;
#   
$strings_deleted = 0;
#   
$strings_changed = 0;

#     
@updated_strings = split ",",$FORM{'updated_strings_joined'};
#     
$FORM{'updated_contents_joined'} =~ s/\r//g;
@updated_contents = split "{!join!}",$FORM{'updated_contents_joined'};
#  -:  =  ;  =  
for $s(0..$#updated_strings)
 { 
  push @updated_elements,$updated_strings[$s];
  push @updated_elements,$updated_contents[$s];
 }
%updated_elements = @updated_elements;
$stat_info .= "->  ... ";

#---------------------------------------------------------------------------------------------------#
#     
#---------------------------------------------------------------------------------------------------#
if($file_version eq "V3.0" && $FORM{'string_flag_corr'} eq 0 && $FORM{'string_return_corr'} eq 0)
 {
  #  : TLK V3.0,       
  $stat_info .= "TLK V3.0,       <br>";
  for $n(0..$FORM{'current_file_strings'})
   {
    #    
    if($updated_elements{$n} =~ /:/)
     { push @delete_string_number,$n; $strings_deleted++; }
    #    
    elsif($n > $file_strings)
     {
      #   
      $new_string_content = $updated_elements{$n};
      #    
      $strings_added++;
      #   
      $new_string_flag = (ord $new_string_content) ? get_DWORD_symbols(1) : get_DWORD_symbols(0);
      #    
      $new_string_sound_link = get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0);
      #     
      $new_strings_data_table .= $new_string_flag.$new_string_sound_link.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content).get_DWORD_symbols(0);
      #     
      $new_strings_content .= $new_string_content;
     }
    else
     {
      #    
      $current_string_data_table = substr $strings_data_table,$n*$string_data_length,$string_data_length;
      #     (28 )
      $part_string = substr $current_string_data_table,0,28;
      #     StringEntriesOffset
      #$current_string_offset = substr $current_string_data_table,28,4;
      #   
      #$current_string_length = substr $current_string_data_table,32,4;
      #    
      $current_sound_length = substr $current_string_data_table,36,4;
      #   
      $current_string_content = substr $strings_content, get_DWORD((substr $current_string_data_table,28,4),0), get_DWORD((substr $current_string_data_table,32,4),0);
      #   
      if($updated_elements{$n})
       {
        $new_string_content = $updated_elements{$n}; $strings_changed++;
        if($FORM{'clear_undo_on_save'} eq 0)
         { push @add_string_number,$n; push @add_string_content,$current_string_content; };
       }
      else{ $new_string_content = $current_string_content; }
      #     
      $new_strings_data_table .= $part_string.get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content).$current_sound_length;
      #     
      $new_strings_content .= $new_string_content;
     }
   }
  #  : TLK V3.0,       
 }
elsif($file_version eq "V3.0" && $FORM{'string_flag_corr'} eq 1 && $FORM{'string_return_corr'} eq 0)
 {
  #  : TLK V3.0,    ,    
  $stat_info .= "TLK V3.0,    ,    <br>";
  for $n(0..$FORM{'current_file_strings'})
   {
    if($updated_elements{$n} =~ /:/)
     { push @delete_string_number,$n; $strings_deleted++; }
    elsif($n > $file_strings)
     {
      $new_string_content = $updated_elements{$n}; $strings_added++;
      $new_string_flag = (ord $current_string_content) ? get_DWORD_symbols(1) : get_DWORD_symbols(0);
      $new_string_sound_link = get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0);
      $new_strings_data_table .= $new_string_flag.$new_string_sound_link.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content).get_DWORD_symbols(0);
      $new_strings_content .= $new_string_content;
     }
    else
     {
      $current_string_data_table = substr $strings_data_table,$n*$string_data_length,$string_data_length;
      $part_string = substr $current_string_data_table,4,24;
         #     
         $current_sound_link = substr $strings_data_table,$string_data_length*$n+4,16;
         $current_sound_link =~ s/\W//g;
      #$current_string_offset = substr $current_string_data_table,28,4;
      #$current_string_length = substr $current_string_data_table,32,4;
      $current_sound_length = substr $current_string_data_table,36,4;
      $current_string_content = substr $strings_content, get_DWORD((substr $current_string_data_table,28,4),0), get_DWORD((substr $current_string_data_table,32,4),0);
      if($updated_elements{$n})
       {
        $new_string_content = $updated_elements{$n}; $strings_changed++;
        if($FORM{'clear_undo_on_save'} eq 0)
         { push @add_string_number,$n; push @add_string_content,$current_string_content; };
       }
      else{ $new_string_content = $current_string_content; }

      #  
      &flag_correction_v3;

      $new_strings_data_table .= $new_string_flag.$part_string.get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content).$current_sound_length;
      $new_strings_content .= $new_string_content;
     }
   }
  #  : TLK V3.0,    ,    
 }
if($file_version eq "V3.0" && $FORM{'string_flag_corr'} eq 0 && $FORM{'string_return_corr'} eq 1)
 {
  #  : TLK V3.0,    ,    
  $stat_info .= "TLK V3.0,    ,    <br>";
  for $n(0..$FORM{'current_file_strings'})
   {
    if($updated_elements{$n} =~ /:/)
     { push @delete_string_number,$n; $strings_deleted++; }
    elsif($n > $file_strings)
     {
      $new_string_content = $updated_elements{$n};
      $strings_added++;
      $new_string_flag = (ord $new_string_content) ? get_DWORD_symbols(1) : get_DWORD_symbols(0);
      $new_strings_data_table .= $new_string_flag.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content).get_DWORD_symbols(0);
      $new_strings_content .= $new_string_content;
     }
    else
     {
      $current_string_data_table = substr $strings_data_table,$n*$string_data_length,$string_data_length;
      $part_string = substr $current_string_data_table,0,28;
      $current_sound_length = substr $current_string_data_table,36,4;
      $current_string_content = substr $strings_content, get_DWORD((substr $current_string_data_table,28,4),0), get_DWORD((substr $current_string_data_table,32,4),0);
      $current_string_content =~ s/\r//g;
      if($updated_elements{$n})
       {
        $new_string_content = $updated_elements{$n}; $strings_changed++;
        if($FORM{'clear_undo_on_save'} eq 0)
         { push @add_string_number,$n; push @add_string_content,$current_string_content; };
       }
      else{ $new_string_content = $current_string_content; }
      $new_strings_data_table .= $part_string.get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content).$current_sound_length;
      $new_strings_content .= $new_string_content;
     }
   }
  #  : TLK V3.0,    ,    
 }
elsif($file_version eq "V3.0" && $FORM{'string_flag_corr'} eq 1 && $FORM{'string_return_corr'} eq 1)
 {
  #  : TLK V3.0,       
  $stat_info .= "TLK V3.0,       <br>";
  for $n(0..$FORM{'current_file_strings'})
   {
    if($updated_elements{$n} =~ /:/)
     { push @delete_string_number,$n; $strings_deleted++; }
    elsif($n > $file_strings)
     {
      $new_string_content = $updated_elements{$n}; $strings_added++;
      $new_string_flag = (ord $current_string_content) ? get_DWORD_symbols(1) : get_DWORD_symbols(0);
      $new_string_sound_link = get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0);
      $new_strings_data_table .= $new_string_flag.$new_string_sound_link.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content).get_DWORD_symbols(0);
      $new_strings_content .= $new_string_content;
     }
    else
     {
      $current_string_data_table = substr $strings_data_table,$n*$string_data_length,$string_data_length;
      $part_string = substr $current_string_data_table,4,24;
         #     
         $current_sound_link = substr $strings_data_table,$string_data_length*$n+4,16;
         $current_sound_link =~ s/\W//g;
      #$current_string_offset = substr $current_string_data_table,28,4;
      #$current_string_length = substr $current_string_data_table,32,4;
      $current_sound_length = substr $current_string_data_table,36,4;
      $current_string_content = substr $strings_content, get_DWORD((substr $current_string_data_table,28,4),0), get_DWORD((substr $current_string_data_table,32,4),0);
      $current_string_content =~ s/\r//g;
      if($updated_elements{$n})
       {
        $new_string_content = $updated_elements{$n}; $strings_changed++;
        if($FORM{'clear_undo_on_save'} eq 0)
         { push @add_string_number,$n; push @add_string_content,$current_string_content; };
       }
      else{ $new_string_content = $current_string_content; }

      #  
      &flag_correction_v3;

      $new_strings_data_table .= $new_string_flag.$part_string.get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content).$current_sound_length;
      $new_strings_content .= $new_string_content;
     }
   }
  #  : TLK V3.0,       
 }
elsif($file_version eq "V1  " && $FORM{'string_flag_corr'} eq 0 && $FORM{'string_return_corr'} eq 0)
 {
  #  : TLK V1,       
  $stat_info .= "TLK V1,       <br>";
  for $n(0..$FORM{'current_file_strings'})
   {
    if($updated_elements{$n} =~ /:/)
     { push @delete_string_number,$n; $strings_deleted++; }
    elsif($n > $file_strings)
     {
      $new_string_content = $updated_elements{$n}; $strings_added++;

      if($new_string_content =~ /<[a-zA-Z]{1}[^>]*>/){ $new_string_flag = get_WORD_symbols(7); }
      elsif(ord $new_string_content){ $new_string_flag = get_WORD_symbols(3); }
      else{ $new_string_flag = get_WORD_symbols(0); }

      $new_string_sound_link = get_DWORD_symbols(0).get_DWORD_symbols(0);
      $new_strings_data_table .= $new_string_flag.$new_string_sound_link.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content);
      $new_strings_content .= $new_string_content;
     }
    else
     {
      $current_string_data_table = substr $strings_data_table,$n*$string_data_length,$string_data_length;
      $part_string = substr $current_string_data_table,0,18;
      #$current_string_offset = substr $current_string_data_table,18,4;
      #$current_string_length = substr $current_string_data_table,22,4;
      $current_string_content = substr $strings_content, get_DWORD((substr $current_string_data_table,18,4),0), get_DWORD((substr $current_string_data_table,22,4),0);
      if($updated_elements{$n})
       {
        $new_string_content = $updated_elements{$n}; $strings_changed++;
        if($FORM{'clear_undo_on_save'} eq 0)
         { push @add_string_number,$n; push @add_string_content,$current_string_content; };
       }
      else{ $new_string_content = $current_string_content; }
      $new_strings_data_table .= $part_string.get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content);
      $new_strings_content .= $new_string_content;
     }
   }
  #  : TLK V1,       
 }
elsif($file_version eq "V1  " && $FORM{'string_flag_corr'} eq 1 && $FORM{'string_return_corr'} eq 0)
 {
  #  : TLK V1,    ,    
  $stat_info .= "TLK V1,    ,    <br>";
  for $n(0..$FORM{'current_file_strings'})
   {
    if($updated_elements{$n} =~ /:/)
     { push @delete_string_number,$n; $strings_deleted++; }
    elsif($n > $file_strings)
     {
      $new_string_content = $updated_elements{$n}; $strings_added++;

      if($new_string_content =~ /<[a-zA-Z]{1}[^>]*>/){ $new_string_flag = get_WORD_symbols(7); }
      elsif(ord $new_string_content){ $new_string_flag = get_WORD_symbols(3); }
      else{ $new_string_flag = get_WORD_symbols(0); }

      $new_string_sound_link = get_DWORD_symbols(0).get_DWORD_symbols(0);
      $new_strings_data_table .= $new_string_flag.$new_string_sound_link.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content);
      $new_strings_content .= $new_string_content;
     }
    else
     {
      $current_string_data_table = substr $strings_data_table,$n*$string_data_length,$string_data_length;
      $part_string = substr $current_string_data_table,2,16;
         #     
         $current_sound_link = substr $strings_data_table,$string_data_length*$n+2,8;
         $current_sound_link =~ s/\W//g;
      #$current_string_offset = substr $current_string_data_table,18,4;
      #$current_string_length = substr $current_string_data_table,22,4;
      $current_string_content = substr $strings_content, get_DWORD((substr $current_string_data_table,18,4),0), get_DWORD((substr $current_string_data_table,22,4),0);
      if($updated_elements{$n})
       {
        $new_string_content = $updated_elements{$n}; $strings_changed++;
        if($FORM{'clear_undo_on_save'} eq 0)
         { push @add_string_number,$n; push @add_string_content,$current_string_content; };
       }
      else{ $new_string_content = $current_string_content; }

      #  
      &flag_correction_v1;
      
      $new_strings_data_table .= $new_string_flag.$part_string.get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content);
      $new_strings_content .= $new_string_content;
     }
   }
  #  : TLK V1,    ,    
 }
elsif($file_version eq "V1  " && $FORM{'string_flag_corr'} eq 0 && $FORM{'string_return_corr'} eq 1)
 {
  #  : TLK V1,    ,    
  $stat_info .= "TLK V1,    ,    <br>";
  for $n(0..$FORM{'current_file_strings'})
   {
    if($updated_elements{$n} =~ /:/)
     { push @delete_string_number,$n; $strings_deleted++; }
    elsif($n > $file_strings)
     {
      $new_string_content = $updated_elements{$n}; $strings_added++;

      if($new_string_content =~ /<[a-zA-Z]{1}[^>]*>/){ $new_string_flag = get_WORD_symbols(7); }
      elsif(ord $new_string_content){ $new_string_flag = get_WORD_symbols(3); }
      else{ $new_string_flag = get_WORD_symbols(0); }

      $new_string_sound_link = get_DWORD_symbols(0).get_DWORD_symbols(0);
      $new_strings_data_table .= $new_string_flag.$new_string_sound_link.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content);
      $new_strings_content .= $new_string_content;
     }
    else
     {
      $current_string_data_table = substr $strings_data_table,$n*$string_data_length,$string_data_length;
      $part_string = substr $current_string_data_table,0,18;
      #$current_string_offset = substr $current_string_data_table,18,4;
      #$current_string_length = substr $current_string_data_table,22,4;
      $current_string_content = substr $strings_content, get_DWORD((substr $current_string_data_table,18,4),0), get_DWORD((substr $current_string_data_table,22,4),0);
      $current_string_content =~ s/\r//g;
      if($updated_elements{$n})
       {
        $new_string_content = $updated_elements{$n}; $strings_changed++;
        if($FORM{'clear_undo_on_save'} eq 0)
         { push @add_string_number,$n; push @add_string_content,$current_string_content; };
       }
      else{ $new_string_content = $current_string_content; }
      $new_strings_data_table .= $part_string.get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content);
      $new_strings_content .= $new_string_content;
     }
   }
  #  : TLK V1,    ,    
 }
elsif($file_version eq "V1  " && $FORM{'string_flag_corr'} eq 1 && $FORM{'string_return_corr'} eq 0)
 {
  #  : TLK V1,       
  $stat_info .= "TLK V1,       <br>";
  for $n(0..$FORM{'current_file_strings'})
   {
    if($updated_elements{$n} =~ /:/)
     { push @delete_string_number,$n; $strings_deleted++; }
    elsif($n > $file_strings)
     {
      $new_string_content = $updated_elements{$n}; $strings_added++;

      if($new_string_content =~ /<[a-zA-Z]{1}[^>]*>/){ $new_string_flag = get_WORD_symbols(7); }
      elsif(ord $new_string_content){ $new_string_flag = get_WORD_symbols(3); }
      else{ $new_string_flag = get_WORD_symbols(0); }
      
      $new_string_sound_link = get_DWORD_symbols(0).get_DWORD_symbols(0);
      $new_strings_data_table .= $new_string_flag.$new_string_sound_link.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content);
      $new_strings_content .= $new_string_content;
     }
    else
     {
      $current_string_data_table = substr $strings_data_table,$n*$string_data_length,$string_data_length;
      $part_string = substr $current_string_data_table,2,16;
         #     
         $current_sound_link = substr $strings_data_table,$string_data_length*$n+2,8;
         $current_sound_link =~ s/\W//g;
      #$current_string_offset = substr $current_string_data_table,18,4;
      #$current_string_length = substr $current_string_data_table,22,4;
      $current_string_content = substr $strings_content, get_DWORD((substr $current_string_data_table,18,4),0), get_DWORD((substr $current_string_data_table,22,4),0);
      $current_string_content =~ s/\r//g;
      if($updated_elements{$n})
       {
        $new_string_content = $updated_elements{$n}; $strings_changed++;
        if($FORM{'clear_undo_on_save'} eq 0)
         { push @add_string_number,$n; push @add_string_content,$current_string_content; };
       }
      else{ $new_string_content = $current_string_content; }

      #  
      &flag_correction_v1;

      $new_strings_data_table .= $new_string_flag.$part_string.get_DWORD_symbols(length $new_strings_content).get_DWORD_symbols(length $new_string_content);
      $new_strings_content .= $new_string_content;
     }
   }
  #  : TLK V1,       
 }

#      
$FORM{'current_file_strings'} -= $strings_deleted;
#  
$delete_string_number_joined = join ",",@delete_string_number;
#     
$add_string_number_joined = join ",",@add_string_number;
$add_string_content_joined = join "{!join!}",@add_string_content;
#       
$add_string_content_joined =~ s/\x5c/\\x5c/g;
$add_string_content_joined =~ s/\x0a/\\x0a/g;
$add_string_content_joined =~ s/\x22/\\x22/g;

#  
$new_header = $file_type.$file_version.(($file_version eq "V3.0") ? get_DWORD_symbols($languageID) : get_WORD_symbols($languageID)).get_DWORD_symbols($FORM{'current_file_strings'} + 1).get_DWORD_symbols($strings_offset - $strings_deleted*$string_data_length + $strings_added*$string_data_length);

$stat_info .= "->  : ".$FORM{'current_file_strings'}." (+1), : ".$strings_added.", : ".$strings_changed.", : ".$strings_deleted."<br>-> : ".(length $new_header)." ,   : ".(length $new_strings_data_table)." ,  : ".(length $new_strings_content)." <br>";

if(length $new_header != $header_length)
 { $stat_info .= ":   (".(length $new_header).") !<br>"; reset_document(); };

if((length $new_strings_data_table)/$string_data_length != ($FORM{'current_file_strings'} + 1))
 { $stat_info .= "->   : ".((length $new_strings_data_table)/$string_data_length)." /   : ".($FORM{'current_file_strings'} + 1)."<br>:   (".(length $new_strings_data_table).")    !<br>"; reset_document(); };

$current_file_name = $main_file;

if($FORM{'make_backup'} eq 1 && -r $current_file_name)
 {
  my $backup_number = 0;
  while(-r ($current_file_name.".backup".$backup_number))
   { $backup_number++ };
  rename $current_file_name, ($current_file_name.".backup".$backup_number);
  $stat_info .= "   :<br><nobr>".$current_file_name.".backup".$backup_number."</nobr><br>";
 };

#    
open FILE,">".$current_file_name;
#    
binmode FILE;
#   
print FILE $new_header.$new_strings_data_table.$new_strings_content;
#  
close FILE;
$stat_info .= " :<br><nobr>".$current_file_name."</nobr><br>->  : ".(length ($new_header.$new_strings_data_table.$new_strings_content))." <br>";

#---------------------------------------------------------------------------------------------------#
#   
#---------------------------------------------------------------------------------------------------#
$stat_info .= "   ".$FORM{'string_number'}." ...<br>";
if(!-r $current_file_name){ $stat_info .= $ERROR_file_read; reset_document(); };

open FILE,$current_file_name;
#     ( )
(undef, undef, undef, undef, undef, undef, undef, $file_size) = stat FILE;
#  
close FILE;
$stat_info .= "->    ... ";
read_block($current_file_name,0,20,$header);
#   
$file_type = substr $header,0,4;
if($file_type ne "TLK "){ $stat_info .= $ERROR_file_type; reset_document(); };

#  
$file_version = substr $header,4,4;
if($file_version eq "V3.0")
 { $header_length = 20; $string_data_length = 40; $stat_info .= "->    ... V3.0<br>"; }
elsif($file_version eq "V1  ")
 { $header_length = 18; $string_data_length = 26; $stat_info .= "->    ... V1<br>"; }
else{ $stat_info .= $ERROR_file_version; reset_document(); }

#  
%language_list = ('0','', '1','', '2','', '3','', '4','', '5','', '6','', '128','', '129',' ', '130',' ', '131','');
#   (    )
$languageID = ($file_version eq "V3.0") ? get_DWORD($header,8) : get_WORD($header,8);
$file_language = $language_list{$languageID};

#     
$file_strings = ($file_version eq "V3.0") ? get_DWORD($header,12) - 1 : get_DWORD($header,10) - 1;
#        
$strings_offset = ($file_version eq "V3.0") ? get_DWORD($header,16) : get_DWORD($header,14);

#      
if($FORM{'string_number'} > $file_strings){ $FORM{'string_number'} = $file_strings; };

#---------------------------------------------------------------------------------------------------#
#  
#---------------------------------------------------------------------------------------------------#
$stat_info .= "->      ... ";
read_block($current_file_name,$string_data_length*$FORM{'string_number'}+$header_length,$string_data_length,$sdt_offset);
if($file_version eq "V3.0")
   {
    #  
    $string_flag = get_DWORD($sdt_offset,0);
    #     
    $sound_link = (substr $sdt_offset,4,16); $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    #     
    $string_offset = ($strings_offset + get_DWORD($sdt_offset,28));
    #    
    $string_length = get_DWORD($sdt_offset,32);
    #      
    $sound_volume = get_DWORD($sdt_offset,20);
    #  /    
    $sound_pitch = get_DWORD($sdt_offset,24);
    #    32-   
    $sound_length = unpack "f", (substr $sdt_offset,36,4);
   }
  elsif($file_version eq "V1  ")
   {
    $string_flag = get_WORD($sdt_offset,0);
    $sound_link = (substr $sdt_offset,2,8); $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    $string_offset = ($strings_offset + get_DWORD($sdt_offset,18));
    $string_length = get_DWORD($sdt_offset,22);
    $sound_volume = get_DWORD($sdt_offset,10);
    $sound_pitch = get_DWORD($sdt_offset,14);
    $sound_length = " ";
   }
$stat_info .= "->    ... ";
read_block($current_file_name,$string_offset,$string_length,$string_text);
#   (5c),   (0a  0d)   (22)  
$string_text =~ s/\x5c/\\x5c/g;
$string_text =~ s/\x0a/\\x0a/g;
if($string_text =~ /\x0d/){ $stat_info .= "->     ...<br>"; $string_text =~ s/\x0d/\\x0d/g; };
$string_text =~ s/\x22/\\x22/g;

# **********************************************
#     
# **********************************************
if($add_file ne "")
 {
  $stat_info .= " tlk-:<br><nobr>".$add_file."</nobr><br>";
  if(!-r $add_file){ $stat_info .= $ERROR_file_read; reset_document(); };
  open FILE2,$add_file; binmode FILE2;
  #   
  seek FILE2,4,0; read FILE2,$file2_version,4;
  #   
  seek FILE2,0,0; read FILE2,$file2_type,4;
  if($file2_type ne "TLK "){ $stat_info .= $ERROR_file_type; }
  elsif($file2_version eq "V3.0")
   {
    #  
    $header2_length = 20;
    #    
    $string2_data_length = 40;
    #    
    seek FILE2,12,0; read FILE2,$file2_strings,4; $file2_strings = (unpack "V", $file2_strings) - 1;
    #        
    seek FILE2,16,0; read FILE2,$strings2_offset,4; $strings2_offset = unpack "V", $strings2_offset;
    #     
    $string2_number = ($FORM{'string_number'} < $file2_strings) ? $FORM{'string_number'} : $file2_strings;
    #   2   
    seek FILE2,$header2_length + $string2_data_length * $string2_number,0; read FILE2,$sdt2_offset,$string2_data_length;
    $string2_offset = $strings2_offset + (unpack "V", substr $sdt2_offset,28,4);
    #   2  
    $string2_length = unpack "V", substr $sdt2_offset,32,4;
    #   2
    seek FILE2,$string2_offset,0; read FILE2,$string2_text,$string2_length;
    $stat_info .= "->   tlk- ... V3.0<br>"; 
   }
  elsif($file2_version eq "V1  ")
   {
    $header2_length = 18;
    $string2_data_length = 26;
    seek FILE2,10,0; read FILE2,$file2_strings,4; $file2_strings = (unpack "V", $file2_strings) - 1;
    seek FILE2,14,0; read FILE2,$strings2_offset,4; $strings2_offset = unpack "V", $strings2_offset;
    $string2_number = ($FORM{'string_number'} < $file2_strings) ? $FORM{'string_number'} : $file2_strings;
    seek FILE2,$header2_length + $string2_data_length * $string2_number,0; read FILE2,$sdt2_offset,$string2_data_length;
    $string2_offset = $strings2_offset + (unpack "V", substr $sdt2_offset,18,4);
    $string2_length = unpack "V", substr $sdt2_offset,22,4;
    seek FILE2,$string2_offset,0; read FILE2,$string2_text,$string2_length;
    $stat_info .= "->   tlk- ... V1<br>"; 
   }
  else{ $stat_info .= $ERROR_file_version; }
  close FILE2;
  if($file2_type eq "TLK " && ($file2_version eq "V3.0" || $file2_version eq "V1  "))
   {
    $stat_info .= "->    ... ".$string2_length."    ".$string2_offset."<br>";
    #   (5c),   (0a  0d)   (22)  
    $string2_text =~ s/\x5c/\\x5c/g;
    $string2_text =~ s/\x0a/\\x0a/g;
    $string2_text =~ s/\x0d/\\x0d/g;
    $string2_text =~ s/\x22/\\x22/g;
   }
 };

$stat_info =~ s/\x5c/\\x5c/g;
my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";

#      
$current_file_name =~ s/\x5c/\\x5c/g;

#      
print <<HTML;
<script type='text/javascript'><!--

if("$FORM{'add_date_on_save'}" == 1 && parent.document.main_form.selected_file_1.checked)
 { parent.document.main_form.load_tlk.value = "$current_file_name"; }
else if("$FORM{'add_date_on_save'}" == 1 && parent.document.main_form.selected_file_2.checked)
 { parent.document.main_form.load_tlk2.value = "$current_file_name"; }

parent.document.main_form.string_content.value = "$string_text";

if("$string2_text")
 {
  parent.document.main_form.string_content2.value = "$string2_text";
  parent.document.main_form.string_content2.title = " .   $string2_number;   /.   .";
 };

if("$#delete_string_number" != "-1")
 { 
  parent.delete_string_number = "$delete_string_number_joined".split(",");
  parent.delete_strings_from_undo();
 };

if("$#add_string_number" != "-1")
 {
  parent.add_string_number = "$add_string_number_joined".split(",");
  parent.add_string_content = "$add_string_content_joined".split("{!join!}");
  parent.add_strings_to_undo();
 };

parent.document.main_form.file_size.value = "$file_size";
parent.document.main_form.file_type.value = "$file_type";
parent.document.main_form.file_version.value = "$file_version";
parent.document.main_form.languageID.value = "$languageID";
parent.document.main_form.strings_offset.value = "$strings_offset";
parent.document.main_form.file_strings.value = "$file_strings";
parent.document.main_form.current_file_strings.value = "$file_strings";
parent.document.getElementById("file_info").innerHTML = ": $file_size , : $file_type, : $file_version, : $file_language (<span style='cursor: help;' title='  , languageID.'>$languageID</span>)";

//parent.document.main_form.string_number.value = "$FORM{'string_number'}";

if("$FORM{'clear_undo_on_save'}" == 1)
 {
  parent.clear_undo();
  parent.document.getElementById("string_info").style.display = "";
  parent.document.getElementById("string_no_info").style.display = "none";
  parent.document.main_form.to_undo_button.style.display = "";
  parent.document.main_form.from_undo_button.style.display = "none";

  parent.document.getElementById("string_flag").innerHTML = "$string_flag";
  parent.document.getElementById("string_length").innerHTML = "$string_length";
  parent.document.getElementById("string_offset").innerHTML = "$string_offset";
  parent.document.getElementById("sound_link").innerHTML = "$sound_link";
  parent.document.getElementById("sound_volume").innerHTML = "$sound_volume";
  parent.document.getElementById("sound_pitch").innerHTML = "$sound_pitch";
  parent.document.getElementById("sound_length").innerHTML = "$sound_length";
 };

parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
parent.document.save_tlk_form.reset();
parent.FLAG_no_action = 0;
parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
// --></script>
HTML
